
%%%%  Polynomicky nvrh PA regultorov s integranou innosou %%%%

function HTMLout = pr10(in,out)
%%% Spustenie polynomickeho toolboxu matlab webserverom
pinit_mws;
imdir = 'C:/www/images';
%imdir = 'E:/www/images/';
cd (in.mldir);
mlid = in.mlid;
wscleanup('*.jpeg',0.2,imdir);
%%%========================================================================
errorcode=0;
%%% Kontrola zadanch parametrov
if ( isempty(in.cit) | isempty(in.men) | isempty(in.cs) | isempty(in.cas) | isempty(in.iv) | isempty(in.fv) | isempty(in.st) | isempty(in.fvp) ),
	out.errormsg='Vyplte vo formulri iadan poloky!';
	errorcode=1;
end

%%% Kontrola dlky polynomov
m = length(in.men);
n = length(in.cs);
if ( n <= m),
	out.errormsg='Diofantick rovnicu nie je mon riei pre zadan rd polynomu c(s). Mus by vy ako je rd prenosu. Skste zada znovu!';
	errorcode=1;
end
%%%========================================================================
if (errorcode==0)
%%% Natanie dt z formulra
cit = in.cit;
men = in.men;
cs = in.cs;
%n = in.n;
cas = in.cas;
iv = in.iv;
fv = in.fv;
st = in.st;
fvp = in.fvp;

%%% Prevod vektora na polynom
cit = str2num(cit);
men = str2num(men);
cs = str2num(cs);
%n = str2double(n);
cas = str2double(cas);
iv = str2double(iv);
fv = str2double(fv);
st = str2double(st);
fvp = str2double(fvp);
%==========================================================================
%%% Vypocet v Matlabe
c = poly2sym(cs,'s');
b = poly2sym(cit,'s');   
a = poly2sym(men,'s');   
%ai = a;
ai = a*s;
%ai = sym2poly(ai);
%ai= poly2sym(ai,'s'); 
%c = (poly2sym(c,'s')^n);
%c = sym2poly(c);
%c = poly2sym(c,'s');

[pp,qq] = axbyc(ai,b,c);
p = pol2mat(pp);
q = pol2mat(qq);

qi = poly2sym(q,'s');
pi = poly2sym(p,'s');
pi = pi*s;
qi = pol2mat(qi);
pi = pol2mat(pi);
%==========================================================================

%%% Nastavanie parametrov simulcie
open_system('pr_10');
set_param('pr_10/vstup','Before',num2str(iv));
set_param('pr_10/vstup','After',num2str(fv));
set_param('pr_10/porucha','Time',num2str(st));
set_param('pr_10/porucha','After',num2str(fvp));
set_param('pr_10/spektr','Denominator',sprintf('[%s]',num2str(pi)));
set_param('pr_10/spektr','Numerator',sprintf('[%s]',num2str(qi)));
set_param('pr_10/Transfer Fcn1','Numerator',sprintf('[%s]',num2str(cit)));
set_param('pr_10/Transfer Fcn1','Denominator',sprintf('[%s]',num2str(men)));
%==========================================================================

%%% Simulcia
sim('pr_10',cas);
fout = figure('visible','off');

subplot(2,1,1);
plot(u(:,1),u(:,2));
xlabel('t');ylabel('u');
%legend('u1');
title('Priebeh riadiacej veliciny pri psoben poruchy podla zadanch parametrov');

subplot(2,1,2);
plot(y1(:,1),y1(:,2));
xlabel('t'); ylabel('y');
%legend('y1');
title('Priebeh riadenia meranej veliciny pri psoben poruchy podla zadanch parametrov');
%==========================================================================

%%% Vstupn dta
out.cit = sprintf('[%s]',num2str(cit));
out.men = sprintf('[%s]',num2str(men));
out.cs = sprintf('[%s]',num2str(cs));
%out.n = n;
out.C = pol2html(cs);
out.B = pol2html(cit);
out.A = pol2html(men);
out.p = pol2html(p);
out.pi = pol2html(pi);
out.q = pol2html(q);
out.cas = cas;
out.iv = iv;
out.fv = fv;
out.st = st;
out.fvp = fvp;
%==========================================================================

%%% Vytlaenie a uloenie grafu do adresra images
WhWr = sprintf('c:/www/images/obr10_%s.jpeg',mlid);
%WhWr = sprintf('e:/www/images/obr10_%s.jpeg',mlid);
print(fout,'-djpeg',WhWr,'-r66.6');
out.GraphFileName = sprintf('/images/obr10_%s.jpeg',mlid);

%%% Predanie dajov programu matweb.exe, ktor odovzd vstupn ablonu 'out_pr10.html' www serveru
templatefile = which('out_10.html');
if (nargin == 1)
   	HTMLout = htmlrep(out, templatefile);
elseif (nargin == 2)
   	HTMLout = htmlrep(out, templatefile, outfile);
end

else
%%% Predanie dajov o chybe programu matweb.exe, ktor odovzd vstupn ablonu 'error_pr10.html' www serveru      
templatefile = which('error_10.html');
if (nargin == 1)
   	HTMLout = htmlrep(out, templatefile);
elseif (nargin == 2)
   	HTMLout = htmlrep(out, templatefile, outfile);
end
end