
%%%%  Systm vyieho rdu s P regultorom %%%%

function HTMLout = pr2(in,out)
%%% Spustenie polynomickeho toolboxu matlab webserverom
pinit_mws;
imdir = 'C:/www/images';
%imdir = 'E:/www/images/';
cd (in.mldir);
mlid = in.mlid;
wscleanup('*.jpeg',0.2,imdir);
fout=figure('visible','off');
%%%========================================================================
errorcode = 0;
%%% Kontrola zadanch parametrov
if ( isempty(in.Z1) | isempty(in.T1) | isempty(in.n) | isempty(in.w) | isempty(in.P) | isempty(in.cas)),
	out.errormsg='Vyplte vo formulri iadan poloky!';
	errorcode = 1;
end
%%%========================================================================

if (errorcode==0)
%%% Natanie dt z formulra
Z1 = in.Z1;
T1 = in.T1;
n = in.n;
w = in.w;
P = in.P;
cas = in.cas;

%%% Prevod dajov z formulra na dta spracovaten Matlabom
Z1 = str2num(Z1);
T1 = str2double(T1);
n = str2double(n);
w = str2double(w);
P = str2double(P);
cas = str2num(cas);

m = (T1*s+1)^n;
m1 = poly2sym(m);
m2 = sym2poly(m1);
men = strcat('[',num2str(m2),']');
%%%========================================================================

%%% Nastavanie parametrov simulcie
open_system('pr_2');
set_param('pr_2/w','Value',num2str(w));
set_param('pr_2/System','Numerator',sprintf(strcat('[',num2str(Z1),']')));
set_param('pr_2/System','Denominator',sprintf('%s',men));
%==========================================================================

%%% Vpoet v Matlabe
%w=1; 
I=0; 
D=0;
%PP=[0.5 1 2];
%PP=6;
PP=P;
vys=cell(1,1);
%vys=cell(1,1);
for j=1:1;
  P = PP(j);
  set_param('pr_2/Pro','Gain',sprintf('%s',num2str(P)));
  set_param('pr_2/Int','Gain',sprintf('%s',num2str(I)));
  set_param('pr_2/Der','Gain',sprintf('%s',num2str(D)));
  sim('pr_2',cas);
  vys{j} = res;
end
%==========================================================================

%%% Generovanie grafu
t1=vys{1}(:,1); %t2= vys{2}(:,1); t3= vys{3}(:,1);
w=vys{1}(:,2);
u1=vys{1}(:,3); %u2= vys{2}(:,3); u3= vys{3}(:,3);
y1=vys{1}(:,4); %y2= vys{2}(:,4); y3= vys{3}(:,4);

subplot(2,1,1);
plot(t1,w,'k:',t1,y1,'r');
%plot(t1,w,'k:',t1,y1,'r-', t2, y2,'g--',t3, y3,'b-.');
%legend(' w', '0.5', '1', '2',4);
title('Vstupn veliina'); xlabel('t'); ylabel('w, y');

subplot(2,1,2);
plot(t1,u1,'g');
%plot(t1,u1,'r-',t2,u2,'g--',t3,u3,'b-.');
%legend('0.5', '1', '2',4);
title('Vstupn veliina');xlabel('t'); ylabel('u');
%==========================================================================

%%% Vstupn dta
out.Z1 = num2str(Z1);
out.Zpre = pol2html(Z1);
out.T1 = T1;
out.n = n;
out.w = w;
out.m2 = pol2html(m2);
out.P = sprintf('%s',num2str(PP));
out.I = sprintf('%s',num2str(I));
out.D = sprintf('%s',num2str(D));
out.cas = cas;
%==========================================================================

%%% Vytlaenie a uloenie grafu do adresra images
WhWr = sprintf('c:/www/images/obr2_%s.jpeg',mlid);
%WhWr = sprintf('e:/www/images/obr2_%s.jpeg',mlid);
print(fout,'-djpeg',WhWr,'-r66.6');
out.GraphFileName = sprintf('/images/obr2_%s.jpeg',mlid);

%%% Predanie dajov programu matweb.exe, ktor odovzd vstupn ablonu 'out_pr2.html' www serveru
templatefile = which('out_pr2.html');
if (nargin == 1)
   	HTMLout = htmlrep(out, templatefile);
elseif (nargin == 2)
   	HTMLout = htmlrep(out, templatefile, outfile);
end

else
%%% Predanie dajov o chybe programu matweb.exe, ktor odovzd vstupn ablonu 'error_pr2.html' www serveru      
templatefile = which('error_pr2.html');
if (nargin == 1)
   	HTMLout = htmlrep(out, templatefile);
elseif (nargin == 2)
   	HTMLout = htmlrep(out, templatefile, outfile);
end
end