
%%%%  Riadenie pl᚝ovho vmennka tepla PI regultorom %%%%

function HTMLout = pr3(in,out)
%%% Spustenie polynomickeho toolboxu matlab webserverom
pinit_mws;
imdir = 'D:/www/images';
%imdir = 'E:/www/images/';
cd (in.mldir);
mlid = in.mlid;
wscleanup('*.jpeg',0.2,imdir);
fout=figure('visible','off');
%%%========================================================================
errorcode=0;
%%% Kontrola zadanch parametrov
if ( isempty(in.Z1) | isempty(in.Z2) | isempty(in.T1) | isempty(in.r) | isempty(in.w) | isempty(in.P) | isempty(in.Ti) | isempty(in.cas)),
	out.errormsg='Vyplte vo formulri iadan poloky!';
	errorcode=1;
end
%%%========================================================================

if (errorcode==0)
%%% Natanie dt z formulra
Z1 = in.Z1;
Z2 = in.Z2;
T1 = in.T1;
r = in.r;
w = in.w;
P = in.P;
Ti = in.Ti;
cas = in.cas;

%%% Prevod dajov z formulra na dta spracovaten Matlabom
Z1 = str2double(Z1);
Z2 = str2double(Z2);
T1 = str2double(T1);
r = str2double(r);
w = str2double(w);
P = str2double(P);
Ti = str2double(Ti);
cas = str2double(cas);

K = Z1/Z2;
men = [T1,1];
%%%========================================================================

%%% Nastavanie parametrov simulcie
open_system('pr_3');
set_param('pr_3/r','Value',num2str(r));
set_param('pr_3/w','Value',num2str(w));
set_param('pr_3/Gain','Gain',num2str(K));
set_param('pr_3/System','Numerator',num2str(Z1));
set_param('pr_3/System','Denominator',sprintf('[%s]',num2str(men)));
set_param('pr_3/Pro','Gain',sprintf('%s',num2str(P)));
%==========================================================================

%%% Vpoet v Matlabe
%Z1=1; Z2=1; T1=1; r=1; w=0; P=10; 
D = 0;
%T1=[2 1 0.2];
%T1 = 0.2;
vys=cell(1,1);
for j=1:1;
  I = P/Ti(j);
  set_param('pr_3/Int','Gain',sprintf('%s',num2str(I)));
  set_param('pr_3/Der','Gain',sprintf('%s',num2str(D)));
  sim('pr_3',cas);
  vys{j} = res;
end
%==========================================================================

%%% Generovanie grafu
t1=vys{1}(:,1); %t2= vys{2}(:,1); t3= vys{3}(:,1);
w=vys{1}(:,2);
u1=vys{1}(:,3); %u2= vys{2}(:,3); u3= vys{3}(:,3);
y1=vys{1}(:,4); %y2= vys{2}(:,4); y3= vys{3}(:,4);

subplot(2,1,1);
plot(t1,w,'k:',t1,y1,'r');
%plot(t1,y1,'k-',t2, y2,'k--',t3, y3,'k-.');
%legend(' w', 'T_i=2', 'T_i=1', 'T_i=0.2');
title('Vstupn veliina'); xlabel('t'); ylabel('y');

subplot(2,1,2);
plot(t1,u1,'g');
% plot(t1,u1,'k-',t2,u2,'k--',t3,u3,'k-.');
% legend('T_i=2', 'T_i=1', 'T_i=0.2');
title('Vstupn veliina'); xlabel('t'); ylabel('u');
%==========================================================================

%%% Vstupn dta
out.Z1 = Z1;
out.Z2 = Z2;
out.T1 = T1;
out.r = r;
out.w = w;
out.P = sprintf('%s',num2str(P));
out.I = sprintf('%s',num2str(I));
out.D = sprintf('%s',num2str(D));
out.cas = cas;
%==========================================================================

%%% Vytlaenie a uloenie grafu do adresra images
WhWr = sprintf('d:/www/images/obr3_%s.jpeg',mlid);
%WhWr = sprintf('e:/www/images/obr3_%s.jpeg',mlid);
print(fout,'-djpeg',WhWr,'-r66.6');
out.GraphFileName = sprintf('/images/obr3_%s.jpeg',mlid);

%%% Predanie dajov programu matweb.exe, ktor odovzd vstupn ablonu 'out_pr3.html' www serveru
templatefile = which('out_pr3.html');
if (nargin == 1)
   	HTMLout = htmlrep(out, templatefile);
elseif (nargin == 2)
   	HTMLout = htmlrep(out, templatefile, outfile);
end

else
%%% Predanie dajov o chybe programu matweb.exe, ktor odovzd vstupn ablonu 'error_pr3.html' www serveru      
templatefile = which('error_pr3.html');
if (nargin == 1)
   	HTMLout = htmlrep(out, templatefile);
elseif (nargin == 2)
   	HTMLout = htmlrep(out, templatefile, outfile);
end
end