
%%%%  Systm vyieho rdu s PID regultorom %%%%

function HTMLout = pr6(in,out)
%%% Spustenie polynomickeho toolboxu matlab webserverom
pinit_mws;
imdir = 'C:/www/images';
%imdir = 'E:/www/images/';
cd (in.mldir);
mlid = in.mlid;
wscleanup('*.jpeg',0.2,imdir);
fout = figure('visible','off');
%%%========================================================================
errorcode=0;
%%% Kontrola zadanch parametrov
if ( isempty(in.Z1) | isempty(in.T1) | isempty(in.n)| isempty(in.w) | isempty(in.Zr) | isempty(in.Ti) | isempty(in.Td) | isempty(in.cas) | isempty(in.up) | isempty(in.low)),
	out.errormsg='Vyplte vo formulri iadan poloky!';
	errorcode=1;
end
%%%========================================================================

if (errorcode==0)
%%% Natanie dt z formulra
Z1 = in.Z1;
T1 = in.T1;
n = in.n;
w = in.w;
Zr = in.Zr;
Ti = in.Ti;
Td = in.Td;
cas = in.cas;
up = in.up;
low = in.low;

%%% Prevod dajov z formulra na dta spracovaten Matlabom
Z1 = str2double(Z1);
T1 = str2double(T1);
n = str2double(n);
w = str2double(w);
Zr = str2double(Zr);
Ti = str2double(Ti);
Td = str2double(Td);
cas = str2double(cas);
up = str2double(up);
low = str2double(low);

%%% Vypocty
m = (T1*s+1)^n;
m1 = poly2sym(m);
m2 = sym2poly(m1);
men = strcat('[',num2str(m2),']');
Tt = sqrt(Ti*Td);
%Tt=2;
%%%========================================================================

%%% Nastavanie parametrov simulcie
open_system('pr_6');
set_param('pr_6/w','Value',num2str(w));
set_param('pr_6/Int','Gain',num2str(Ti));
set_param('pr_6/Int1','Gain',num2str(Ti));
set_param('pr_6/cas_konst','Gain',num2str(Tt));
set_param('pr_6/System','Numerator',num2str(Z1));
set_param('pr_6/System','Denominator',sprintf('%s',men));
set_param('pr_6/System1','Numerator',num2str(Z1));
set_param('pr_6/System1','Denominator',sprintf('%s',men));
set_param('pr_6/Pro','Gain',num2str(Zr));
set_param('pr_6/Pro1','Gain',num2str(Zr));
set_param('pr_6/Saturation','UpperLimit',num2str(up));
set_param('pr_6/Saturation','LowerLimit',num2str(low));
set_param('pr_6/Saturation1','UpperLimit',num2str(up));
set_param('pr_6/Saturation1','LowerLimit',num2str(low));
%==========================================================================

%%% Generovanie grafu
sim('pr_6',cas);
vys1 = res;
vys2 = res1;

vys = vys1;
t=vys(:,1); w=vys(:,2); u=vys(:,3); y=vys(:,4); integ=vys(:,5);
subplot(2,1,1)
plot(t,w,'k:',t,y,'r',t,u,'g',t,integ,'b');
legend(' w', 'y', 'u', 'integ',4);
xlabel('t'); %ylabel('');
title('(a)')

vys = vys2;
t=vys(:,1); w=vys(:,2); u=vys(:,3); y=vys(:,4); integ=vys(:,5);
subplot(2,1,2)
plot(t,w,'k:',t,y,'r',t,u,'g',t,integ,'b');
legend(' w', 'y', 'u', 'integ',4);
xlabel('t'); %ylabel('');
title('(b)')
%==========================================================================

%%% Vstupn dta
out.Z1 = Z1;
out.T1 = T1;
out.n = n;
out.w = w;
out.m2 = pol2html(m2);
out.Zr = sprintf('%s',num2str(Zr));
out.Ti = sprintf('%s',num2str(Ti));
out.Td = sprintf('%s',num2str(Td));
out.Tt = Tt;
out.up = up;
out.low = low;
out.cas = cas;
%==========================================================================

%%% Vytlaenie a uloenie grafu do adresra images
WhWr = sprintf('c:/www/images/obr6_%s.jpeg',mlid);
%WhWr = sprintf('e:/www/images/obr6_%s.jpeg',mlid);
print(fout,'-djpeg',WhWr,'-r66.6');
out.GraphFileName = sprintf('/images/obr6_%s.jpeg',mlid);

%%% Predanie dajov programu matweb.exe, ktor odovzd vstupn ablonu 'out_pr6.html' www serveru
templatefile = which('out_pr6.html');
if (nargin == 1)
   	HTMLout = htmlrep(out, templatefile);
elseif (nargin == 2)
   	HTMLout = htmlrep(out, templatefile, outfile);
end

else
%%% Predanie dajov o chybe programu matweb.exe, ktor odovzd vstupn ablonu 'error_pr6.html' www serveru      
templatefile = which('error_pr6.html');
if (nargin == 1)
   	HTMLout = htmlrep(out, templatefile);
elseif (nargin == 2)
   	HTMLout = htmlrep(out, templatefile, outfile);
end
end