
%%%%  Nvrh regultora Strejcovou metodou %%%%

function HTMLout = pr8a(in,out)
%%% Spustenie polynomickho toolboxu matlab webserverom
pinit_mws;
imdir = 'C:/www/images';
%imdir = 'E:/www/images/';
cd (in.mldir);
mlid = in.mlid;
wscleanup('*.jpeg',0.2,imdir);
fout = figure('visible','off');
%%%========================================================================
errorcode=0;
%%% Kontrola zadanch parametrov
if ( isempty(in.Z) | isempty(in.T) | isempty(in.n)| isempty(in.w) | isempty(in.cas)),
	out.errormsg='Vyplte vo formulri iadan poloky!';
	errorcode=1;
end
if (str2double(in.reg) <= 2)
    if(str2double(in.n)<2)
        out.errormsg='Pre syntzu P alebo PI regultora, zvote rd systmu minimlne n = 2!';
        errorcode=1; 
   end
end
if (str2double(in.reg) == 3)
    if(str2double(in.n)<3)
        out.errormsg='Pre syntzu PID regultora, zvote rd systmu minimlne n = 3!';
        errorcode=1; 
   end
end
%%%========================================================================

if (errorcode==0)
%%% Natanie dt z formulra
Z = in.Z;
T = in.T;
n = in.n;
w = in.w;
cas = in.cas;

%%% Prevod dajov z formulra na dta spracovaten Matlabom
Z = str2double(Z);
T = str2double(T);
n = str2double(n);
w = str2double(w);
cas = str2double(cas);

%%% Vpoet v Matlabe
m = (T*s+1)^n;
m1 = poly2sym(m);
m2 = sym2poly(m1);
men = strcat('[',num2str(m2),']');
%%%==========================================================================

%%% TYP REGULATORA
if (in.reg == '1')
%%% Vypocet P regulatora Strejcovou metodou
        Zr = (1/Z)*(1/(n-1));
        P = Zr; 
        I = 0;
        D = 0;
        popis = 'P regultorom';
end

if (in.reg == '2')
%%% Vypocet PI regulatora Strejcovou metodou
        Zr = (1/Z)*((n+2)/(4*(n-1)));
        Ti = T*((n+2)/3);
        P = Zr; 
        I = Zr/Ti; 
        D = 0;
        popis = 'PI regultorom';
end

if (in.reg == '3')
%%% Vypocet PID regulatora Strejcovou metodou
        Zr = (1/Z)*((7*n+16)/(16*(n-2)));
        Ti = T*((7*n+16)/15);
        Td = T*(((n+1)*(n+3))/(7*n+16));
        P = Zr; 
        I = Zr/Ti; 
        D = Zr*Td;
        popis = 'PID regultorom';
end
%%%==========================================================================

%%% Nastavanie parametrov simulcie
open_system('pr_8a');
set_param('pr_8a/w','Value',num2str(w));
set_param('pr_8a/System','Numerator',num2str(Z));
set_param('pr_8a/System','Denominator',sprintf('%s',men));
set_param('pr_8a/Pro','Gain',num2str(P));
set_param('pr_8a/Int','Gain',num2str(I));
set_param('pr_8a/Der','Gain',num2str(D));
%==========================================================================

%%% Generovanie grafu
sim('pr_8a',cas);
t=res(:,1); w=res(:,2); u=res(:,3); y=res(:,4);
plot(t,w,'k:',t,y,'r',t,u,'g');
legend(' w', ' y', ' u');
xlabel('t'); ylabel('w,y,u');
%==========================================================================

%%% Vstupn dta
out.Z = Z;
out.T = T;
out.n = n;
out.w = w;
out.popis = popis;
out.m2 = pol2html(m2);
out.P = sprintf('%s',num2str(P));
out.I = sprintf('%s',num2str(I));
out.D = sprintf('%s',num2str(D));
out.cas = cas;
%==========================================================================

%%% Vytlaenie a uloenie grafu do adresra images
WhWr = sprintf('c:/www/images/obr8a_%s.jpeg',mlid);
%WhWr = sprintf('e:/www/images/obr8a_%s.jpeg',mlid);
print(fout,'-djpeg',WhWr,'-r66.6');
out.GraphFileName = sprintf('/images/obr8a_%s.jpeg',mlid);

%%% Predanie dajov programu matweb.exe, ktor odovzd vstupn ablonu 'out_pr8a.html' www serveru
templatefile = which('out_pr8a.html');
if (nargin == 1)
   	HTMLout = htmlrep(out, templatefile);
elseif (nargin == 2)
   	HTMLout = htmlrep(out, templatefile, outfile);
end

else
%%% Predanie dajov o chybe programu matweb.exe, ktor odovzd vstupn ablonu 'error_pr8a.html' www serveru      
templatefile = which('error_pr8a.html');
if (nargin == 1)
   	HTMLout = htmlrep(out, templatefile);
elseif (nargin == 2)
   	HTMLout = htmlrep(out, templatefile, outfile);
end
end